#include "WindowsWidgetFactory.h"
#include "MotifWidgetFactory.h"
#include "Widget.h"

#define MOTIF

int main(int argc, char *argv[])
{
	WidgetFactory *widget_factory;
#ifdef MOTIF
	widget_factory = new MotifWidgetFactory;
#else // WINDOWS
	widget_factory = new WindowsWidgetFactory;
#endif

	Widget* w[2] = { widget_factory->create_button(),
		widget_factory->create_menu() };
	w[0]->draw();
	w[1]->draw();

}
